const BASE_URL = 'http://localhost:3210';
const headers = {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer 8cb655d4eb266192627aad22a80b50e083b9ee74a1854b8b19b97aac1a01d440'
};

async function getAllRecipes({pagination = 0, relatedPost = undefined, createdAt = undefined, language='default'}) {
    const response = await fetch(BASE_URL + '/getAllRecipes/' + pagination + '/' + relatedPost + '/' + createdAt + '/' + language, {
        method: 'GET',
        headers
    });

    return response.json();
};

async function getRecipeById({postId, pagination = 0, language='default'}) {
    const response = await fetch(BASE_URL + '/getRecipeById/' + postId + '/' + pagination + '/' + language, {
        method: 'GET',
        headers
    });

    return response.json();
};

async function getRecipesWithFilters({pagination = 0, relatedPost = undefined, createdAt = undefined, language='default'}) {
    const response = await fetch(BASE_URL + '/getRecipesWithFilters/' + pagination + '/' + relatedPost + '/' + createdAt + '/' + language, {
        method: 'GET',
        headers
    });

    return response.json();
};

async function getUserInfo({postId, pagination = 0, language='default'}) {
    const response = await fetch(BASE_URL + '/getUserInfo/' + postId + '/' + pagination + '/' + language, {
        method: 'GET',
        headers
    });

    return response.json();
};

async function getUserinfoById({data, pagination = 0, relatedPost = undefined, createdAt = undefined, language='default'}) {
    const response = await fetch(BASE_URL + '/getUserinfoById/' + pagination + '/' + relatedPost + '/' + createdAt + '/' + language, {
        method: 'POST',
        headers,
        body: JSON.stringify(data)
    });

    return response.json(); 
};

async function setDiet({data, language='default'}) {
    const response = await fetch(BASE_URL + '/setDiet/' + language, {
        method: 'POST',
        headers,
        body: JSON.stringify(data)
    });

    return response.json(); 
};

async function setIngredient({data, language='default'}) {
    const response = await fetch(BASE_URL + '/setIngredient/' + language, {
        method: 'POST',
        headers,
        body: JSON.stringify(data)
    });

    return response.json(); 
};

async function setRecipe({data, language='default'}) {
    const response = await fetch(BASE_URL + '/setRecipe/' + language, {
        method: 'POST',
        headers,
        body: JSON.stringify(data)
    });

    return response.json(); 
};

async function setUserInfo({data, language='default'}) {
    const response = await fetch(BASE_URL + '/setUserInfo/' + language, {
        method: 'POST',
        headers,
        body: JSON.stringify(data)
    });

    return response.json(); 
};


module.exports = {
getAllRecipes,
getRecipeById,
getRecipesWithFilters,
getUserInfo,
getUserinfoById,
setDiet,
setIngredient,
setRecipe,
setUserInfo
};

