const transfers = require('./transfers.js');
const fs = require('fs');
const BASE_URL = '/';

function orbbyteRequests(app) {
app.get(BASE_URL, async function (req, res) {
    fs.readFile(__dirname + '/../index.html', 'utf8', (err, text) => {
        res.send(text);
    });
});

app.get(BASE_URL + 'getAllRecipes/:pagination/:relatedPost?/:createdAt?/:language?', async function (req, res) {
        res.status(200).json(await transfers.getAllRecipes({
            pagination: req.params.pagination, 
            relatedPost: req.params.relatedPost === 'undefined' ? null : req.params.relatedPost,
            createdAt: req.params.createdAt === 'undefined' ? null : req.params.createdAt,
            language: req.params.language
        }));
    });

app.get(BASE_URL + 'getRecipeById/:postId/:pagination/:language?', async function (req, res) {
        res.status(200).json(await transfers.getRecipeById({
            postId: req.params.postId,
            pagination: req.params.pagination,
            language: req.params.language
        }));
    });

app.get(BASE_URL + 'getRecipesWithFilters/:pagination/:relatedPost?/:createdAt?/:language?', async function (req, res) {
        res.status(200).json(await transfers.getRecipesWithFilters({
            pagination: req.params.pagination, 
            relatedPost: req.params.relatedPost === 'undefined' ? null : req.params.relatedPost,
            createdAt: req.params.createdAt === 'undefined' ? null : req.params.createdAt,
            language: req.params.language
        }));
    });

app.get(BASE_URL + 'getUserInfo/:postId/:pagination/:language?', async function (req, res) {
        res.status(200).json(await transfers.getUserInfo({
            postId: req.params.postId,
            pagination: req.params.pagination,
            language: req.params.language
        }));
    });

app.post(BASE_URL + 'getUserinfoById/:pagination/:relatedPost?/:createdAt?/:language?', async function (req, res) {
        res.status(200).json(await transfers.getUserinfoById({
            ...req.body, 
            pagination: req.params.pagination, 
            relatedPost: req.params.relatedPost === 'undefined' ? null : req.params.relatedPost,
            createdAt:  req.params.createdAt === 'undefined' ? null : req.params.createdAt,
            language: req.params.language
        }));
    });

app.post(BASE_URL + 'setDiet/:language?', async function (req, res) {
        res.status(200).json(await transfers.setDiet(req.body, req.params.language));
    });

app.post(BASE_URL + 'setIngredient/:language?', async function (req, res) {
        res.status(200).json(await transfers.setIngredient(req.body, req.params.language));
    });

app.post(BASE_URL + 'setRecipe/:language?', async function (req, res) {
        res.status(200).json(await transfers.setRecipe(req.body, req.params.language));
    });

app.post(BASE_URL + 'setUserInfo/:language?', async function (req, res) {
        res.status(200).json(await transfers.setUserInfo(req.body, req.params.language));
    });

} 

 
module.exports = {
    orbbyteRequests
};

