const orbbyte = require('orbbyte')({
    host: process.env.DB_HOST,
    user: process.env.DB_USER,
    password: process.env.DB_PWD,
    database: process.env.DB_DATABASE,
    port: process.env.DB_PORT,
    prefix: process.env.DB_PREFIX
});

async function getAllRecipes({pagination, relatedPost, createdAt, language='default'}) {
    const response = await orbbyte.connect({
        key: '593191cb8e774f504125d5ff8ea5b9e75ec34a5dd01ed7afca577a14f8eeb4dd',
        pagination,
        relatedPost,
        createdAt,
        language
    });

    return response;
};

async function getRecipeById({postId, pagination, language='default'}) {
    const response = await orbbyte.connect({
        key: 'ffca7da45ca0c4be5cc7582483f939bc064b16c7e802c6968681f0fa4dee356e',
        postId,
        pagination,
        language
    });

    return response;
};

async function getRecipesWithFilters({pagination, relatedPost, createdAt, language='default'}) {
    const response = await orbbyte.connect({
        key: '6e431339174df412bc2e1e1c34a5f7ea1f41a70d88e5118d94ae3d5e8c9a86c5',
        pagination,
        relatedPost,
        createdAt,
        language
    });

    return response;
};

async function getUserInfo({postId, pagination, language='default'}) {
    const response = await orbbyte.connect({
        key: '5054c7a6064f7da6af84d639631cfdbc270a5117c4ec475de4b67726379a4fae',
        postId,
        pagination,
        language
    });

    return response;
};

async function getUserinfoById({idDiet, pagination, relatedPost, createdAt, language='default'}) {
    const response = await orbbyte.connect({
        key: '2fe7feda5c3f69c79dcc3565c07d73e89959a013f49de964b38ebc733ad0d080',
        filter: [idDiet],
        pagination,
        relatedPost,
        createdAt,
        language
    });

    return response;
};

async function setDiet({fbRef, startDate, diet, status, numDays, dietType, newRef, goal, kcal, proteins, lipids, polyunsaturated, colesterol, acidFat182, monounsaturated, saturated, acidFat183, calcium, selenium, iodine, sodium, potassium, magnessium, phosphorous, iron, fiber, vitaminD, vitaminA, folato, vitaminC, b12, thiamine, riboflavin, b6, niacine, sugar, carbohydrates, relatedPost}, language='default') {
    const response = await orbbyte.connect({
        key: '80d72bb805a5e83f38bf76d109e0e3592a8f7035df4e3b55676f52b36ef89c92',
        content: [fbRef, startDate, diet, status, numDays, dietType, newRef, goal, kcal, proteins, lipids, polyunsaturated, colesterol, acidFat182, monounsaturated, saturated, acidFat183, calcium, selenium, iodine, sodium, potassium, magnessium, phosphorous, iron, fiber, vitaminD, vitaminA, folato, vitaminC, b12, thiamine, riboflavin, b6, niacine, sugar, carbohydrates],
        relatedPost,
        language
    });

    return response;
};

async function setIngredient({name, image, niacin, oleic, omegas, palmitic, perDVColesterol, phosphorus, polyunsaturated, potasim, processes, proteins, puntuation, riboflavin, sturated, sinonims, sodium, stearic, sugar, thiamine, totalMonosaturatedFatRatio, totalUnsaturatedFatRatio, unitsXcent, valColesterol, vitaminA, vitaminB12, vitaminB6, vitaminC, vitaminD, vitaminE, vitamins, water, relatedPost}, language='default') {
    const response = await orbbyte.connect({
        key: '2229fba8082b8b6e3fda13916564451b05c15b46188434b2c6abe1673684790d',
        content: [name, image, niacin, oleic, omegas, palmitic, perDVColesterol, phosphorus, polyunsaturated, potasim, processes, proteins, puntuation, riboflavin, sturated, sinonims, sodium, stearic, sugar, thiamine, totalMonosaturatedFatRatio, totalUnsaturatedFatRatio, unitsXcent, valColesterol, vitaminA, vitaminB12, vitaminB6, vitaminC, vitaminD, vitaminE, vitamins, water],
        relatedPost,
        language
    });

    return response;
};

async function setRecipe({title, time, numPersons, userId, complexity, count, fav, favoriteCategory, score, status, allergens, mealType, tags, ingredients, steps, relatedPost}, language='default') {
    const response = await orbbyte.connect({
        key: '58ed48ba0a3d4563141ff17fd10ab79024e8bd08f21e66384f28f8a29862ab02',
        content: [title, time, numPersons, userId, complexity, count, fav, favoriteCategory, score, status, allergens, mealType, tags, ingredients, steps],
        relatedPost,
        language
    });

    return response;
};

async function setUserInfo({idUser, idDiet, fbUser, activityType, birthdate, breastfeeding, height, weight, measures, allergens, diseases, goal, gender, menopause, pregnant, recipesTaken, avoidCategories, ingredientsToAvoid, preparationTime, location, relatedPost}, language='default') {
    const response = await orbbyte.connect({
        key: '493513195c20908b5de20fc341eb4163aeec193c1255a07078641a17d878d933',
        content: [idUser, idDiet, fbUser, activityType, birthdate, breastfeeding, height, weight, measures, allergens, diseases, goal, gender, menopause, pregnant, recipesTaken, avoidCategories, ingredientsToAvoid, preparationTime, location],
        relatedPost,
        language
    });

    return response;
};

module.exports = {
getAllRecipes,
getRecipeById,
getRecipesWithFilters,
getUserInfo,
getUserinfoById,
setDiet,
setIngredient,
setRecipe,
setUserInfo
};

